moSetGetConfigXml = {};

function moSetGetConfigXml:loadConfig(self)
	local path = getUserProfileAppPath();
	local file = path.."/multiOverlaySettings.xml";
	if not fileExists(file) then
		return false;
	end;
	local Xml = loadXMLFile("MultiOverlaySettings_XML", file, "MultiOverlay");
	moDefault.xml = Xml;
	if getXMLBool(Xml, "MultiOverlay.artDesign") ~= nil then moGuiMiniPDAsetGet.artDesign = getXMLBool(Xml, "MultiOverlay.artDesign");end;
	if getXMLBool(Xml, "MultiOverlay.newFruitNames.regFruitNames") ~= nil then moDefault.regNewFruitNames = getXMLBool(Xml, "MultiOverlay.newFruitNames.regFruitNames");end;
	if getXMLBool(Xml, "MultiOverlay.newStationNames.regStationNames") ~= nil then moDefault.regNewStationNames = getXMLBool(Xml, "MultiOverlay.newStationNames.regStationNames");end;
	if getXMLInt(Xml, "MultiOverlay.newStationNames.maxStationsProPage") then moDefault.maxStationsProPage = getXMLInt(Xml, "MultiOverlay.newStationNames.maxStationsProPage");end;
	if moDefault.maxStationsProPage <=2 then moDefault.maxStationsProPage = 14;end;
	moDefault.endStationPage = moDefault.maxStationsProPage;
	if getXMLBool(Xml, "MultiOverlay.loadDemandPage2") ~= nil then moDefault.loadDemandPage2 = getXMLBool(Xml, "MultiOverlay.loadDemandPage2");end;
	if getXMLInt(Xml, "MultiOverlay.updateInterval") then MultiOverlay.timerUpdate.interval = getXMLInt(Xml, "MultiOverlay.updateInterval");end;	
	if getXMLInt(Xml, "MultiOverlay.size") then moSetGetGui.pdaMenueSize = getXMLInt(Xml, "MultiOverlay.size")/1000;end;	
	if getXMLInt(Xml, "MultiOverlay.lastPage") then moSetGetGui.pdaActivePage = getXMLInt(Xml, "MultiOverlay.lastPage");end;
	if getXMLInt(Xml, "MultiOverlay.mapPriceSwitch") then moDefault.mapPriceSwitch = getXMLInt(Xml, "MultiOverlay.mapPriceSwitch");end;
	if getXMLInt(Xml, "MultiOverlay.mapFruitsSwitch") then moDefault.mapFruitsSwitch = getXMLInt(Xml, "MultiOverlay.mapFruitsSwitch");end;
	if getXMLBool(Xml, "MultiOverlay.adjustZoom") ~= nil then moSetGetGui.adjustZoom = getXMLBool(Xml, "MultiOverlay.adjustZoom");end;
	if getXMLBool(Xml, "MultiOverlay.combiBgaSilo") ~= nil then moGuiMiniPDAsetGet.combiBgaSilo = getXMLBool(Xml, "MultiOverlay.combiBgaSilo");end;
	--if getXMLBool(Xml, "MultiOverlay.VI") ~= nil then moSetGetGui.pdaVI.on = getXMLBool(Xml, "MultiOverlay.VI");end;
	--if getXMLBool(Xml, "MultiOverlay.VIiconDesign") ~= nil then moSetGetGui.pdaVI.iconDesign = getXMLBool(Xml, "MultiOverlay.VIiconDesign");end;
	--if getXMLInt(Xml, "MultiOverlay.VIhideSwitch") then moSetGetGui.pdaVI.hideSwitch = getXMLInt(Xml, "MultiOverlay.VIhideSwitch");end;
	if getXMLFloat(Xml, "MultiOverlay.screenAspectRatio") then moSetGetGui.screenAspectRatio = getXMLFloat(Xml, "MultiOverlay.screenAspectRatio");end;
	if getXMLBool(Xml, "MultiOverlay.screenAspectRatioAuto") ~= nil then moSetGetGui.screenAspectRatioAuto = getXMLBool(Xml, "MultiOverlay.screenAspectRatioAuto");end;
	if moSetGetGui.screenAspectRatioAuto then
		if g_screenAspectRatio >= 1.3 and g_screenAspectRatio <= 1.4 then moSetGetGui.screenAspectRatio = 4.61;end;
		if g_screenAspectRatio >= 1.25 and g_screenAspectRatio <= 1.29 then moSetGetGui.screenAspectRatio = 4.8;end;
		if g_screenAspectRatio >= 1.5 then moSetGetGui.screenAspectRatio = 0;end;
	end;
	if getXMLInt(Xml, "MultiOverlay.multiFarmSilo") then moDefault.multiFarmSilo = getXMLInt(Xml, "MultiOverlay.multiFarmSilo");end;
	loadVI(self, Xml);
	return true;
end;

function moSetGetConfigXml:loadSetXmlMiniPDAslots(self)		
	if moDefault.xml ~= nil then		
		local allPara = true;
		local i=0;
		local name = nil;
		while true do
			local groupSlotNameTag = ("MultiOverlay.miniPDA.slot(%d)"):format(i);
			local idx = getXMLInt(moDefault.xml, groupSlotNameTag.."#id");
			if idx == nil then
				if moGuiMiniPDAsetGet.slotsActive >= i then
					print("!!!! WARNING !!!! Found corrupt MultiOverlay Hud miniPDA slot id=".. i.. " name=nil");
					print("!!!! disable miniPDA (create your new) manipulate not xml settings !!!!");
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.isKeySwitchActive = false;
					moGuiMiniPDAsetGet.keySwitchLast = 1;
				end;
				break;
			end;						
			if allPara then	
				allPara = false;
				if getXMLBool(moDefault.xml, groupSlotNameTag.."#isActive") ~= nil then moGuiMiniPDAsetGet.isActive = getXMLBool(moDefault.xml, groupSlotNameTag.."#isActive");end;
				if getXMLInt(moDefault.xml, groupSlotNameTag.."#slotsActive") then moGuiMiniPDAsetGet.slotsActive = getXMLInt(moDefault.xml, groupSlotNameTag.."#slotsActive");end;
				if getXMLInt(moDefault.xml, groupSlotNameTag.."#slotOpen") then moGuiMiniPDAsetGet.slotOpen = getXMLInt(moDefault.xml, groupSlotNameTag.."#slotOpen");end;
				if moGuiMiniPDAsetGet.isActive and moGuiMiniPDAsetGet.slotsActive == 0 or moGuiMiniPDAsetGet.slotsActive > moGuiMiniPDAsetGet.slotsMax then 
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.slotOpen = 0;
				end;								
				if getXMLBool(moDefault.xml, groupSlotNameTag.."#keyMouseSwitch") ~= nil then moGuiMiniPDAsetGet.isKeySwitchActive = getXMLBool(moDefault.xml, groupSlotNameTag.."#keyMouseSwitch");end;				
				if moGuiMiniPDAsetGet.isKeySwitchActive and moGuiMiniPDAsetGet.slotOpen ~= 0 then moGuiMiniPDAsetGet.keySwitchLast = moGuiMiniPDAsetGet.slotOpen;end;
				if getXMLInt(moDefault.xml, groupSlotNameTag.."#alignment") then moGuiMiniPDAsetGet.alignment = getXMLInt(moDefault.xml, groupSlotNameTag.."#alignment");end;
				if getXMLBool(moDefault.xml, groupSlotNameTag.."#artDesignDistance") ~= nil then moGuiMiniPDAsetGet.artDesignDistance = getXMLBool(moDefault.xml, groupSlotNameTag.."#artDesignDistance");end;
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#slotDistance") then					
					moGuiMiniPDAsetGet.slotDistance = getXMLFloat(moDefault.xml, groupSlotNameTag.."#slotDistance");					
					moSetGetGui:refreshAlignment(self, false, false);
				end;
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#zoomOutIn") then moGuiMiniPDAsetGet.zoomOutIn = getXMLFloat(moDefault.xml, groupSlotNameTag.."#zoomOutIn");end;
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#posX") then moGuiMiniPDAsetGet.posX = getXMLFloat(moDefault.xml, groupSlotNameTag.."#posX");end;					
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#posY") then moGuiMiniPDAsetGet.posY = getXMLFloat(moDefault.xml, groupSlotNameTag.."#posY");end;
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#openX") then moGuiMiniPDAsetGet.openX = getXMLFloat(moDefault.xml, groupSlotNameTag.."#openX");end;
				if getXMLFloat(moDefault.xml, groupSlotNameTag.."#openY") then moGuiMiniPDAsetGet.openY = getXMLFloat(moDefault.xml, groupSlotNameTag.."#openY");end;
			else				
				if getXMLString(moDefault.xml, groupSlotNameTag.."#name") and string.find(moGuiMiniPDAsetGet.slotNameOn, getXMLString(moDefault.xml, groupSlotNameTag.."#name")) then
					name = getXMLString(moDefault.xml, groupSlotNameTag.."#name");
					moGuiMiniPDAsetGet.slot[i] = name;
					if getXMLInt(moDefault.xml, groupSlotNameTag.."#switch") then moGuiMiniPDAsetGet.slotSwitch[i] = getXMLInt(moDefault.xml, groupSlotNameTag.."#switch");end;				
					if not string.find(moGuiMiniPDAsetGet.slotSwitchOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotSwitch[i] = 0;					
					end;					
					if getXMLFloat(moDefault.xml, groupSlotNameTag.."#openX") then	moGuiMiniPDAsetGet.slotOpenX[i] = getXMLFloat(moDefault.xml, groupSlotNameTag.."#openX");end;
					if not string.find(moGuiMiniPDAsetGet.slotOpenSlotNewPosOn, name) then						
						moGuiMiniPDAsetGet.slotOpenX[i] = 0;
						moGuiMiniPDAsetGet.slotOpenY[i] = 0;
					else
						if getXMLFloat(moDefault.xml, groupSlotNameTag.."#openY") then moGuiMiniPDAsetGet.slotOpenY[i] = getXMLFloat(moDefault.xml, groupSlotNameTag.."#openY");end;
						if moGuiMiniPDAsetGet.slotOpenX[i] <= 0.0001 then moGuiMiniPDAsetGet.slotOpenX[i] = moGuiMiniPDAsetGet.openX;end;
						if moGuiMiniPDAsetGet.slotOpenY[i] <= 0.0001 then moGuiMiniPDAsetGet.slotOpenY[i] = moGuiMiniPDAsetGet.openY;end;
					end;					
					if getXMLBool(moDefault.xml, groupSlotNameTag.."#closeOpenForeignHuds") ~= nil then moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = getXMLBool(moDefault.xml, groupSlotNameTag.."#closeOpenForeignHuds");end;
					if not string.find(moGuiMiniPDAsetGet.slotCloseOpenForeignHudsOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = false;
					end;
					if getXMLBool(moDefault.xml, groupSlotNameTag.."#closeOpenHud") ~= nil then moGuiMiniPDAsetGet.slotCloseOpenHud[i] = getXMLBool(moDefault.xml, groupSlotNameTag.."#closeOpenHud");end;											
					moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = false; --not active,set default					
					
					if getXMLBool(moDefault.xml, groupSlotNameTag.."#warning") ~= nil then moGuiMiniPDAsetGet.slotWarning[i] = getXMLBool(moDefault.xml, groupSlotNameTag.."#warning");end;
					if not string.find(moGuiMiniPDAsetGet.slotWarningOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotWarning[i] = false;						
					end;
					if getXMLBool(moDefault.xml, groupSlotNameTag.."#warningSound") ~= nil then moGuiMiniPDAsetGet.slotWarningSound[i] = getXMLBool(moDefault.xml, groupSlotNameTag.."#warningSound");end;
					moGuiMiniPDAsetGet.slotWarningSound[i] = false; --not active,set default
					if getXMLBool(moDefault.xml, groupSlotNameTag.."#warningLiveTicker") ~= nil then moGuiMiniPDAsetGet.slotWarningLiveTicker[i] = getXMLBool(moDefault.xml, groupSlotNameTag.."#warningLiveTicker");end;
					moGuiMiniPDAsetGet.slotWarningLiveTicker[i] = false; --not active,set default
				else
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.isKeySwitchActive = false;
					moGuiMiniPDAsetGet.keySwitchLast = 1;
					print("!!!! WARNING !!!! Found corrupt MultiOverlay Hud miniPDA slot id=".. i.. " name=".. tostring(name));
					print("!!!! Refresh MultiOverlay Hud miniPDA................set nil");									
				end;				
			end;
			i=i+1;
        end				
	end;	
end;

function loadVI(self, Xml)
	if moDefault.xml ~= nil then
		local a = 0;		
		local groupVINameTag = ("MultiOverlay.vehicleInspector.values(%d)"):format(a);
		if getXMLBool(moDefault.xml, groupVINameTag.."#on") ~= nil then moSetGetGui.pdaVI.on = getXMLBool(moDefault.xml, groupVINameTag.."#on");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#iconDesign") ~= nil then moSetGetGui.pdaVI.iconDesign = getXMLBool(moDefault.xml, groupVINameTag.."#iconDesign");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#speedDisplay") ~= nil then moSetGetGui.pdaVI.speedDisplay = getXMLBool(moDefault.xml, groupVINameTag.."#speedDisplay");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#fieldDisplay") ~= nil then moSetGetGui.pdaVI.fieldDisplay = getXMLBool(moDefault.xml, groupVINameTag.."#fieldDisplay");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#vehicleDisplay") ~= nil then moSetGetGui.pdaVI.vehicleDisplay = getXMLBool(moDefault.xml, groupVINameTag.."#vehicleDisplay");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#backGround") ~= nil then moSetGetGui.pdaVI.backGround = getXMLBool(moDefault.xml, groupVINameTag.."#backGround");end;
		if getXMLBool(moDefault.xml, groupVINameTag.."#distanceLine") ~= nil then moSetGetGui.pdaVI.distanceLine = getXMLBool(moDefault.xml, groupVINameTag.."#distanceLine");end;
		if getXMLInt(moDefault.xml, groupVINameTag.."#vehicleName") then moSetGetGui.pdaVI.vehicleName = getXMLInt(moDefault.xml, groupVINameTag.."#vehicleName");end;
		if getXMLInt(moDefault.xml, groupVINameTag.."#playerName") then moSetGetGui.pdaVI.fullPlayerName = getXMLInt(moDefault.xml, groupVINameTag.."#playerName");end;
		if getXMLInt(moDefault.xml, groupVINameTag.."#moreInfo") then moSetGetGui.pdaVI.seeMoreInfo = getXMLInt(moDefault.xml, groupVINameTag.."#moreInfo");end;
		if getXMLInt(moDefault.xml, groupVINameTag.."#hideSwitch") then moSetGetGui.pdaVI.hideSwitch = getXMLInt(moDefault.xml, groupVINameTag.."#hideSwitch");end;
		if getXMLInt(moDefault.xml, groupVINameTag.."#compactDisplay") then moSetGetGui.pdaVI.compactDisplay = getXMLInt(moDefault.xml, groupVINameTag.."#compactDisplay");end;
		if getXMLFloat(moDefault.xml, groupVINameTag.."#size") then moSetGetGui.pdaVI.size = getXMLFloat(moDefault.xml, groupVINameTag.."#size");end;
		if getXMLFloat(moDefault.xml, groupVINameTag.."#distance") then moSetGetGui.pdaVI.distance = getXMLFloat(moDefault.xml, groupVINameTag.."#distance");end;
		if getXMLFloat(moDefault.xml, groupVINameTag.."#zoomOutIn") then moSetGetGui.pdaVI.zoomOutInVI = getXMLFloat(moDefault.xml, groupVINameTag.."#zoomOutIn");end;
		if moSetGetGui.pdaVI.iconDesign then
			if not moSetGetGui.pdaVI.speedDisplay then moSetGetGui.pdaVI.speedDisplay = true;end;
		end;
	end;
end;

function moSetGetConfigXml:loadSetNewXmlFruitNames(self)
	moFillTypesNewName = {};
	local found = false;
	if moDefault.xml ~= nil then		
		local i=0;
        while true do
			i=i+1;
			local groupNewFruitNameTag = ("MultiOverlay.newFruitNames.name(%d)"):format(i);			
			local idx = getXMLInt(moDefault.xml, groupNewFruitNameTag.."#id");
			if idx == nil or idx < 1 or idx > moDefault.lengthNewFruitNamesMax then
				break;
			end;
			found = true;
			moFillTypesNewName["id"..i] = {};
			moFillTypesNewName["id"..i].oldName = getXMLString(moDefault.xml, groupNewFruitNameTag.."#oldName");
			moFillTypesNewName["id"..i].newName = getXMLString(moDefault.xml, groupNewFruitNameTag.."#newName");		  
        end				
	end;
	if found then
		moDefault.lengthFruitName = 10;
		moSetGetFillTypes:setFirstFillTypes(self, true);
	end;
end;

function moSetGetConfigXml:loadSetNewXmlStationNames(self)
	moStationesNewName = {};	
	local found = false;
	if moDefault.xml ~= nil then		
		local i=0;
        while true do
			i=i+1;
			local groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(i);			
			local idx = getXMLInt(moDefault.xml, groupNewStationNameTag.."#id");
			if idx == nil or idx < 1 or idx > moDefault.lengthNewStationNamesMax then
				break;
			end;
			found = true;
			moStationesNewName["id"..i] = {};
			moStationesNewName["id"..i].oldName = getXMLString(moDefault.xml, groupNewStationNameTag.."#oldName");
			moStationesNewName["id"..i].newName = getXMLString(moDefault.xml, groupNewStationNameTag.."#newName");		  
        end		
	end;
	if found then
		moDefault.lengthStation = 0;
		moDefault.lengthStationName = 0;
		moSetGetStationes:setFirstStationTriggers(self, true);
	end;
end;

function moSetGetConfigXml:saveConfig(self)
	local path = getUserProfileAppPath();
	local file = path.."/multiOverlaySettings.xml";
	local Xml;	
	Xml = createXMLFile("MultiOverlaySettings_XML", file, "MultiOverlay")
	if Xml ~= nil then		
		setXMLBool(Xml, "MultiOverlay.artDesign", moGuiMiniPDAsetGet.artDesign);
		local artDesign = false;
		local replaceDirFile;
		if moGuiMiniPDAsetGet.artDesign then
			replaceDirFile = string.gsub(moGuiMiniPDAsetGet.designDir, path, "");
			if string.len(replaceDirFile) >= 2 then artDesign = true;end;
		end;			
		if artDesign then
			setXMLString(Xml, "MultiOverlay.artDesignDirAndXML", replaceDirFile.. moGuiMiniPDAsetGet.designName);
		else
			setXMLString(Xml, "MultiOverlay.artDesignDirAndXML", "optionalDir/xmlfile (without .xml)");
		end;
		setXMLInt(Xml, "MultiOverlay.updateInterval", MultiOverlay.timerUpdate.interval);
		setXMLInt(Xml, "MultiOverlay.size", moSetGetGui.pdaMenueSize*1000);
		setXMLInt(Xml, "MultiOverlay.lastPage", moSetGetGui.pdaActivePage);
		setXMLInt(Xml, "MultiOverlay.mapPriceSwitch", moDefault.mapPriceSwitch);
		setXMLInt(Xml, "MultiOverlay.mapFruitsSwitch", moDefault.mapFruitsSwitch);
		setXMLBool(Xml, "MultiOverlay.loadDemandPage2", moDefault.loadDemandPage2);
		setXMLBool(Xml, "MultiOverlay.adjustZoom", moSetGetGui.adjustZoom);
		setXMLBool(Xml, "MultiOverlay.combiBgaSilo", moGuiMiniPDAsetGet.combiBgaSilo);
		--setXMLBool(Xml, "MultiOverlay.VI", moSetGetGui.pdaVI.on);
		--setXMLBool(Xml, "MultiOverlay.VIiconDesign", moSetGetGui.pdaVI.iconDesign);
		--setXMLInt(Xml, "MultiOverlay.VIhideSwitch", moSetGetGui.pdaVI.hideSwitch);
		setXMLBool(Xml, "MultiOverlay.screenAspectRatioAuto", moSetGetGui.screenAspectRatioAuto);
		setXMLFloat(Xml, "MultiOverlay.screenAspectRatio", moSetGetGui.screenAspectRatio);
		setXMLInt(Xml, "MultiOverlay.multiFarmSilo", moDefault.multiFarmSilo);
		setXMLBool(Xml, "MultiOverlay.newFruitNames.regFruitNames", moDefault.regNewFruitNames);
		setXMLBool(Xml, "MultiOverlay.newStationNames.regStationNames", moDefault.regNewStationNames);
		setXMLInt(Xml, "MultiOverlay.newStationNames.maxStationsProPage", moDefault.maxStationsProPage);
		saveNewXmlFruitNames(self, Xml);		
		saveNewXmlStationNames(self, Xml);			
		saveMiniPDAslots(self, Xml);
		saveVI(self, Xml);
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!! MultiOverlay Hud save file error "..file);
	end;	
end;

function saveMiniPDAslots(self, Xml)			
	local allPara = true;
	for a=0, moGuiMiniPDAsetGet.slotsActive do				
		local groupSlotNameTag = ("MultiOverlay.miniPDA.slot(%d)"):format(a);
		if allPara then
			allPara = false;
			setXMLInt(Xml, groupSlotNameTag.."#id", a);
			if moGuiMiniPDAsetGet.isActive and moGuiMiniPDAsetGet.slotsActive == 0 then
				setXMLBool(Xml, groupSlotNameTag.."#isActive", false);
			else
				setXMLBool(Xml, groupSlotNameTag.."#isActive", moGuiMiniPDAsetGet.isActive);	
			end;			
			setXMLInt(Xml, groupSlotNameTag.."#slotsActive", moGuiMiniPDAsetGet.slotsActive);			
			setXMLInt(Xml, groupSlotNameTag.."#slotOpen", moGuiMiniPDAsetGet.slotOpen);			
			setXMLBool(Xml, groupSlotNameTag.."#keyMouseSwitch", moGuiMiniPDAsetGet.isKeySwitchActive);
			setXMLInt(Xml, groupSlotNameTag.."#alignment", moGuiMiniPDAsetGet.alignment);
			setXMLFloat(Xml, groupSlotNameTag.."#slotDistance", moGuiMiniPDAsetGet.slotDistance);
			if moGuiMiniPDAsetGet.artDesignDistance and not moGuiMiniPDAsetGet.artDesign then
				setXMLBool(Xml, groupSlotNameTag.."#artDesignDistance", false);
			else
				setXMLBool(Xml, groupSlotNameTag.."#artDesignDistance", moGuiMiniPDAsetGet.artDesignDistance);
			end;
			setXMLFloat(Xml, groupSlotNameTag.."#zoomOutIn", moGuiMiniPDAsetGet.zoomOutIn);			
			setXMLFloat(Xml, groupSlotNameTag.."#posX", moGuiMiniPDAsetGet.posX);
			setXMLFloat(Xml, groupSlotNameTag.."#posY", moGuiMiniPDAsetGet.posY);
			setXMLFloat(Xml, groupSlotNameTag.."#openX", moGuiMiniPDAsetGet.openX);
			setXMLFloat(Xml, groupSlotNameTag.."#openY", moGuiMiniPDAsetGet.openY);
		else			
			setXMLInt(Xml, groupSlotNameTag.."#id", a);
			setXMLString(Xml, groupSlotNameTag.."#name", moGuiMiniPDAsetGet.slot[a]);
			local slotSwitch = tonumber(moGuiMiniPDAsetGet.slotSwitch[a]);
			if string.find(moGuiMiniPDAsetGet.slotSwitchOn, moGuiMiniPDAsetGet.slot[a]) then
				if slotSwitch == 0 then slotSwitch = 1;end;
			end;			
			setXMLInt(Xml, groupSlotNameTag.."#switch", slotSwitch);			
			setXMLBool(Xml, groupSlotNameTag.."#warning", moGuiMiniPDAsetGet.slotWarning[a]);
			setXMLBool(Xml, groupSlotNameTag.."#warningSound", moGuiMiniPDAsetGet.slotWarningSound[a]);
			setXMLBool(Xml, groupSlotNameTag.."#warningLiveTicker", moGuiMiniPDAsetGet.slotWarningSound[a]);			
			if moGuiMiniPDAsetGet.slotOpenX[a] <= 0.0001 then  moGuiMiniPDAsetGet.slotOpenX[a] = moGuiMiniPDAsetGet.openX;end;
			if moGuiMiniPDAsetGet.slotOpenY[a] <= 0.0001 then  moGuiMiniPDAsetGet.slotOpenY[a] = moGuiMiniPDAsetGet.openY;end;
			setXMLFloat(Xml, groupSlotNameTag.."#openX", moGuiMiniPDAsetGet.slotOpenX[a]);
			setXMLFloat(Xml, groupSlotNameTag.."#openY", moGuiMiniPDAsetGet.slotOpenY[a]);
			setXMLBool(Xml, groupSlotNameTag.."#closeOpenHud", moGuiMiniPDAsetGet.slotCloseOpenHud[a]);
			setXMLBool(Xml, groupSlotNameTag.."#closeOpenForeignHuds", moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[a]);
		end;
	end;	
end;

function saveVI(self, Xml)
	local a = 0;		
	local groupVINameTag = ("MultiOverlay.vehicleInspector.values(%d)"):format(a);
	setXMLInt(Xml, groupVINameTag.."#id", a);
	setXMLBool(Xml, groupVINameTag.."#on", moSetGetGui.pdaVI.on);
	setXMLBool(Xml, groupVINameTag.."#iconDesign", moSetGetGui.pdaVI.iconDesign);
	setXMLBool(Xml, groupVINameTag.."#speedDisplay", moSetGetGui.pdaVI.speedDisplay);
	setXMLBool(Xml, groupVINameTag.."#fieldDisplay", moSetGetGui.pdaVI.fieldDisplay);
	setXMLBool(Xml, groupVINameTag.."#vehicleDisplay", moSetGetGui.pdaVI.vehicleDisplay);
	setXMLBool(Xml, groupVINameTag.."#backGround", moSetGetGui.pdaVI.backGround);
	setXMLBool(Xml, groupVINameTag.."#distanceLine", moSetGetGui.pdaVI.distanceLine);
	setXMLBool(Xml, groupVINameTag.."#upDisplay", moSetGetGui.pdaVI.upDisplay);
	setXMLInt(Xml, groupVINameTag.."#vehicleName", moSetGetGui.pdaVI.vehicleName);
	setXMLInt(Xml, groupVINameTag.."#playerName", moSetGetGui.pdaVI.fullPlayerName);
	setXMLInt(Xml, groupVINameTag.."#moreInfo", moSetGetGui.pdaVI.seeMoreInfo);
	setXMLInt(Xml, groupVINameTag.."#hideSwitch", moSetGetGui.pdaVI.hideSwitch);
	setXMLInt(Xml, groupVINameTag.."#compactDisplay", moSetGetGui.pdaVI.compactDisplay);
	setXMLFloat(Xml, groupVINameTag.."#size", moSetGetGui.pdaVI.size);
	setXMLFloat(Xml, groupVINameTag.."#distance", moSetGetGui.pdaVI.distance);
	setXMLFloat(Xml, groupVINameTag.."#zoomOutIn", moSetGetGui.pdaVI.zoomOutInVI);
	setXMLInt(Xml, groupVINameTag.."#autoPos", moSetGetGui.pdaVI.autoPos);
end;

function saveNewXmlFruitNames(self, Xml)	
	if moFillTypesNewName ~= nil then		
		local a = 0;		
		local groupNewFruitNameTag = ("MultiOverlay.newFruitNames.name(%d)"):format(a);
		setXMLInt(Xml, groupNewFruitNameTag.."#id", a);
		setXMLString(Xml, groupNewFruitNameTag.."#oldName", "fruitName");
		setXMLString(Xml, groupNewFruitNameTag.."#newName", "fruitName");		
		a = a+1;		
		function setIndex(_index)			
			if _index ~= nil and moFillTypesNewName[_index] ~= nil and moFillTypesNewName[_index].oldName ~= nil then				
				groupNewFruitNameTag = ("MultiOverlay.newFruitNames.name(%d)"):format(a);
				setXMLInt(Xml, groupNewFruitNameTag.."#id", a);
				setXMLString(Xml, groupNewFruitNameTag.."#oldName", moFillTypesNewName[_index].oldName);
				setXMLString(Xml, groupNewFruitNameTag.."#newName", moFillTypesNewName[_index].newName);
				a = a+1;
			end;			
		end
		table.foreach(moFillTypesNewName, setIndex);				
	end;
end;

function saveNewXmlStationNames(self, Xml)	
	if moStationesNewName ~= nil then		
		local a = 0;		
		local groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(a);
		setXMLInt(Xml, groupNewStationNameTag.."#id", a);
		setXMLString(Xml, groupNewStationNameTag.."#oldName", "stationName");
		setXMLString(Xml, groupNewStationNameTag.."#newName", "stationName");		
		a = a+1;		
		function setIndex(_index)			
			if _index ~= nil and moStationesNewName[_index] ~= nil and moStationesNewName[_index].oldName ~= nil then				
				groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(a);
				setXMLInt(Xml, groupNewStationNameTag.."#id", a);
				setXMLString(Xml, groupNewStationNameTag.."#oldName", moStationesNewName[_index].oldName);
				setXMLString(Xml, groupNewStationNameTag.."#newName", moStationesNewName[_index].newName);
				a = a+1;
			end;			
		end
		table.foreach(moStationesNewName, setIndex);			
	end;	
end;