moSetGetPlaceableTrees = {};

---upk mods---
function moSetGetPlaceableTrees:setPlaceableTreesUpdate(self)	
	if not moDefault.upkMod then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableTrees ";end;
		return;
	end;
	moDefaultUpkPlaceable.trees = "";
	moDefaultUpkPlaceable.lengthTrees = 0;
	moDefault.warningPlaceableTreesProductivity = 100;
	moPlaceableTrees = {};	
	function checkPlaceableTree(xmlUpkModString, name)
		if g_currentMission.placeables[xmlUpkModString] ~= nil then		
			setUpkPlaceableTree(self, xmlUpkModString, name)				
		end;
	end;
	for a=1, moDefaultUpkPlaceable.treesSearch do
		local xmlUpkModString = string.lower(moDefault.gameDir.. moDefaultUpkPlaceable.treesMod[a]);
		local treeName = moDefaultUpkPlaceable.treesName[a];
		checkPlaceableTree(xmlUpkModString, treeName);
	end;	
	if moDefaultUpkPlaceable.lengthTrees == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableTrees ";end;	
	end;	
end;

function setUpkPlaceableTree(self, xmlUpkModString, treeName)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ", "");	
	if moPlaceableTrees[treeName] == nil then
		moDefaultUpkPlaceable.lengthTrees = moDefaultUpkPlaceable.lengthTrees+1;
		moPlaceableTrees[treeName] = {};
		moPlaceableTrees[treeName].lengthActive = 0;
		moPlaceableTrees[treeName].lengthNotActive = 0;
		moPlaceableTrees[treeName].treeName = unpack(moLanguage.extern[treeName.. "Tree".. moDefault.language]);	
		moPlaceableTrees[treeName].modName = nil;
		moPlaceableTrees[treeName].capacity = 0;		
		moPlaceableTrees[treeName].fillLevel = 0;		
		moPlaceableTrees[treeName].fillType = 0;		
		moPlaceableTrees[treeName].fillTypeName = "unknow";
		moPlaceableTrees[treeName].bestPrice = 0;
		moPlaceableTrees[treeName].productivity = 0;
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	local setFirstFillType = false;	
	local setFirstModName = false;
	for k, v in pairs(g_currentMission.placeables[xmlUpkModString]) do		
		if not setFirstModName then setFirstModName = true;moPlaceableTrees[treeName].modName = g_currentMission.placeables[xmlUpkModString][k].base.name;end;
		moPlaceableTrees[treeName].capacity = moPlaceableTrees[treeName].capacity+g_currentMission.placeables[xmlUpkModString][k].base.p_capacity;
		local fillLevel = g_currentMission.placeables[xmlUpkModString][k].base:getFillLevel();
		if fillLevel > 0 then 
			moPlaceableTrees[treeName].lengthActive = moPlaceableTrees[treeName].lengthActive+1;
			moPlaceableTrees[treeName].fillLevel = moPlaceableTrees[treeName].fillLevel+fillLevel;				
		else
			moPlaceableTrees[treeName].lengthNotActive = moPlaceableTrees[treeName].lengthNotActive+1;
		end;
		if fillLevel > 0 and not setFirstFillType then
			setFirstFillType = true;
			moPlaceableTrees[treeName].fillType = g_currentMission.placeables[xmlUpkModString][k].base:getFillType();
			local desc = Fillable.fillTypeIndexToDesc[moPlaceableTrees[treeName].fillType];
			if desc ~= nil then 
				moPlaceableTrees[treeName].fillTypeName = moFillTypes[desc.index].fruitName;
				moPlaceableTrees[treeName].bestPrice = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			end;			
		end;			
	end;
	if moPlaceableTrees[treeName].modName == nil then table.remove(moPlaceableTrees[treeName]);return;end;
	moDefaultUpkPlaceable.trees = moDefaultUpkPlaceable.trees.. treeName.. " ";
	if moPlaceableTrees[treeName].lengthActive > 0 then
		setPlaceableTreeProductivityColor(self, treeName);
	end;
end;

function setPlaceableTreeProductivityColor(self, treeName)
	local capacity = moPlaceableTrees[treeName].capacity; --/(moPlaceableTrees[treeName].lengthActive+moPlaceableTrees[treeName].lengthNotActive);
	--capacityt = capacity*moPlaceableTrees[treeName].lengthActive;
	local fillLevel = moPlaceableTrees[treeName].fillLevel;
	local ratio = string.format("%0.0f", Utils.getNoNil(fillLevel/capacity*100, 0));
	moPlaceableTrees[treeName].productivity = ratio;	
	moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	if tonumber(moDefault.warningPlaceableTreesProductivity) >= tonumber(ratio) then 
		moDefault.warningPlaceableTreesProductivity = tonumber(ratio);	
	end;
end;